//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private ETIAlertCross[] cacheETIAlertCross = null;
        private ETIAverageTrender[] cacheETIAverageTrender = null;
        private ETIDynamicStrength[] cacheETIDynamicStrength = null;
        private ETIPriceLeader[] cacheETIPriceLeader = null;
        private ETIQuickTrend[] cacheETIQuickTrend = null;
        private ETIVolumeWatch[] cacheETIVolumeWatch = null;

        private static ETIAlertCross checkETIAlertCross = new ETIAlertCross();
        private static ETIAverageTrender checkETIAverageTrender = new ETIAverageTrender();
        private static ETIDynamicStrength checkETIDynamicStrength = new ETIDynamicStrength();
        private static ETIPriceLeader checkETIPriceLeader = new ETIPriceLeader();
        private static ETIQuickTrend checkETIQuickTrend = new ETIQuickTrend();
        private static ETIVolumeWatch checkETIVolumeWatch = new ETIVolumeWatch();

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public ETIAlertCross ETIAlertCross(bool enableAudio, int separation, string soundFileDown, string soundFileUp)
        {
            return ETIAlertCross(Input, enableAudio, separation, soundFileDown, soundFileUp);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public ETIAlertCross ETIAlertCross(Data.IDataSeries input, bool enableAudio, int separation, string soundFileDown, string soundFileUp)
        {
            if (cacheETIAlertCross != null)
                for (int idx = 0; idx < cacheETIAlertCross.Length; idx++)
                    if (cacheETIAlertCross[idx].EnableAudio == enableAudio && cacheETIAlertCross[idx].Separation == separation && cacheETIAlertCross[idx].SoundFileDown == soundFileDown && cacheETIAlertCross[idx].SoundFileUp == soundFileUp && cacheETIAlertCross[idx].EqualsInput(input))
                        return cacheETIAlertCross[idx];

            lock (checkETIAlertCross)
            {
                checkETIAlertCross.EnableAudio = enableAudio;
                enableAudio = checkETIAlertCross.EnableAudio;
                checkETIAlertCross.Separation = separation;
                separation = checkETIAlertCross.Separation;
                checkETIAlertCross.SoundFileDown = soundFileDown;
                soundFileDown = checkETIAlertCross.SoundFileDown;
                checkETIAlertCross.SoundFileUp = soundFileUp;
                soundFileUp = checkETIAlertCross.SoundFileUp;

                if (cacheETIAlertCross != null)
                    for (int idx = 0; idx < cacheETIAlertCross.Length; idx++)
                        if (cacheETIAlertCross[idx].EnableAudio == enableAudio && cacheETIAlertCross[idx].Separation == separation && cacheETIAlertCross[idx].SoundFileDown == soundFileDown && cacheETIAlertCross[idx].SoundFileUp == soundFileUp && cacheETIAlertCross[idx].EqualsInput(input))
                            return cacheETIAlertCross[idx];

                ETIAlertCross indicator = new ETIAlertCross();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.EnableAudio = enableAudio;
                indicator.Separation = separation;
                indicator.SoundFileDown = soundFileDown;
                indicator.SoundFileUp = soundFileUp;
                Indicators.Add(indicator);
                indicator.SetUp();

                ETIAlertCross[] tmp = new ETIAlertCross[cacheETIAlertCross == null ? 1 : cacheETIAlertCross.Length + 1];
                if (cacheETIAlertCross != null)
                    cacheETIAlertCross.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheETIAlertCross = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public ETIAverageTrender ETIAverageTrender()
        {
            return ETIAverageTrender(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public ETIAverageTrender ETIAverageTrender(Data.IDataSeries input)
        {
            if (cacheETIAverageTrender != null)
                for (int idx = 0; idx < cacheETIAverageTrender.Length; idx++)
                    if (cacheETIAverageTrender[idx].EqualsInput(input))
                        return cacheETIAverageTrender[idx];

            lock (checkETIAverageTrender)
            {
                if (cacheETIAverageTrender != null)
                    for (int idx = 0; idx < cacheETIAverageTrender.Length; idx++)
                        if (cacheETIAverageTrender[idx].EqualsInput(input))
                            return cacheETIAverageTrender[idx];

                ETIAverageTrender indicator = new ETIAverageTrender();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                ETIAverageTrender[] tmp = new ETIAverageTrender[cacheETIAverageTrender == null ? 1 : cacheETIAverageTrender.Length + 1];
                if (cacheETIAverageTrender != null)
                    cacheETIAverageTrender.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheETIAverageTrender = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public ETIDynamicStrength ETIDynamicStrength()
        {
            return ETIDynamicStrength(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public ETIDynamicStrength ETIDynamicStrength(Data.IDataSeries input)
        {
            if (cacheETIDynamicStrength != null)
                for (int idx = 0; idx < cacheETIDynamicStrength.Length; idx++)
                    if (cacheETIDynamicStrength[idx].EqualsInput(input))
                        return cacheETIDynamicStrength[idx];

            lock (checkETIDynamicStrength)
            {
                if (cacheETIDynamicStrength != null)
                    for (int idx = 0; idx < cacheETIDynamicStrength.Length; idx++)
                        if (cacheETIDynamicStrength[idx].EqualsInput(input))
                            return cacheETIDynamicStrength[idx];

                ETIDynamicStrength indicator = new ETIDynamicStrength();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                ETIDynamicStrength[] tmp = new ETIDynamicStrength[cacheETIDynamicStrength == null ? 1 : cacheETIDynamicStrength.Length + 1];
                if (cacheETIDynamicStrength != null)
                    cacheETIDynamicStrength.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheETIDynamicStrength = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public ETIPriceLeader ETIPriceLeader(int separationDot, int separationTriangle)
        {
            return ETIPriceLeader(Input, separationDot, separationTriangle);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public ETIPriceLeader ETIPriceLeader(Data.IDataSeries input, int separationDot, int separationTriangle)
        {
            if (cacheETIPriceLeader != null)
                for (int idx = 0; idx < cacheETIPriceLeader.Length; idx++)
                    if (cacheETIPriceLeader[idx].SeparationDot == separationDot && cacheETIPriceLeader[idx].SeparationTriangle == separationTriangle && cacheETIPriceLeader[idx].EqualsInput(input))
                        return cacheETIPriceLeader[idx];

            lock (checkETIPriceLeader)
            {
                checkETIPriceLeader.SeparationDot = separationDot;
                separationDot = checkETIPriceLeader.SeparationDot;
                checkETIPriceLeader.SeparationTriangle = separationTriangle;
                separationTriangle = checkETIPriceLeader.SeparationTriangle;

                if (cacheETIPriceLeader != null)
                    for (int idx = 0; idx < cacheETIPriceLeader.Length; idx++)
                        if (cacheETIPriceLeader[idx].SeparationDot == separationDot && cacheETIPriceLeader[idx].SeparationTriangle == separationTriangle && cacheETIPriceLeader[idx].EqualsInput(input))
                            return cacheETIPriceLeader[idx];

                ETIPriceLeader indicator = new ETIPriceLeader();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.SeparationDot = separationDot;
                indicator.SeparationTriangle = separationTriangle;
                Indicators.Add(indicator);
                indicator.SetUp();

                ETIPriceLeader[] tmp = new ETIPriceLeader[cacheETIPriceLeader == null ? 1 : cacheETIPriceLeader.Length + 1];
                if (cacheETIPriceLeader != null)
                    cacheETIPriceLeader.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheETIPriceLeader = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public ETIQuickTrend ETIQuickTrend(int separation)
        {
            return ETIQuickTrend(Input, separation);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public ETIQuickTrend ETIQuickTrend(Data.IDataSeries input, int separation)
        {
            if (cacheETIQuickTrend != null)
                for (int idx = 0; idx < cacheETIQuickTrend.Length; idx++)
                    if (cacheETIQuickTrend[idx].Separation == separation && cacheETIQuickTrend[idx].EqualsInput(input))
                        return cacheETIQuickTrend[idx];

            lock (checkETIQuickTrend)
            {
                checkETIQuickTrend.Separation = separation;
                separation = checkETIQuickTrend.Separation;

                if (cacheETIQuickTrend != null)
                    for (int idx = 0; idx < cacheETIQuickTrend.Length; idx++)
                        if (cacheETIQuickTrend[idx].Separation == separation && cacheETIQuickTrend[idx].EqualsInput(input))
                            return cacheETIQuickTrend[idx];

                ETIQuickTrend indicator = new ETIQuickTrend();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Separation = separation;
                Indicators.Add(indicator);
                indicator.SetUp();

                ETIQuickTrend[] tmp = new ETIQuickTrend[cacheETIQuickTrend == null ? 1 : cacheETIQuickTrend.Length + 1];
                if (cacheETIQuickTrend != null)
                    cacheETIQuickTrend.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheETIQuickTrend = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public ETIVolumeWatch ETIVolumeWatch()
        {
            return ETIVolumeWatch(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public ETIVolumeWatch ETIVolumeWatch(Data.IDataSeries input)
        {
            if (cacheETIVolumeWatch != null)
                for (int idx = 0; idx < cacheETIVolumeWatch.Length; idx++)
                    if (cacheETIVolumeWatch[idx].EqualsInput(input))
                        return cacheETIVolumeWatch[idx];

            lock (checkETIVolumeWatch)
            {
                if (cacheETIVolumeWatch != null)
                    for (int idx = 0; idx < cacheETIVolumeWatch.Length; idx++)
                        if (cacheETIVolumeWatch[idx].EqualsInput(input))
                            return cacheETIVolumeWatch[idx];

                ETIVolumeWatch indicator = new ETIVolumeWatch();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                ETIVolumeWatch[] tmp = new ETIVolumeWatch[cacheETIVolumeWatch == null ? 1 : cacheETIVolumeWatch.Length + 1];
                if (cacheETIVolumeWatch != null)
                    cacheETIVolumeWatch.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheETIVolumeWatch = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ETIAlertCross ETIAlertCross(bool enableAudio, int separation, string soundFileDown, string soundFileUp)
        {
            return _indicator.ETIAlertCross(Input, enableAudio, separation, soundFileDown, soundFileUp);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.ETIAlertCross ETIAlertCross(Data.IDataSeries input, bool enableAudio, int separation, string soundFileDown, string soundFileUp)
        {
            return _indicator.ETIAlertCross(input, enableAudio, separation, soundFileDown, soundFileUp);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ETIAverageTrender ETIAverageTrender()
        {
            return _indicator.ETIAverageTrender(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.ETIAverageTrender ETIAverageTrender(Data.IDataSeries input)
        {
            return _indicator.ETIAverageTrender(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ETIDynamicStrength ETIDynamicStrength()
        {
            return _indicator.ETIDynamicStrength(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.ETIDynamicStrength ETIDynamicStrength(Data.IDataSeries input)
        {
            return _indicator.ETIDynamicStrength(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ETIPriceLeader ETIPriceLeader(int separationDot, int separationTriangle)
        {
            return _indicator.ETIPriceLeader(Input, separationDot, separationTriangle);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.ETIPriceLeader ETIPriceLeader(Data.IDataSeries input, int separationDot, int separationTriangle)
        {
            return _indicator.ETIPriceLeader(input, separationDot, separationTriangle);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ETIQuickTrend ETIQuickTrend(int separation)
        {
            return _indicator.ETIQuickTrend(Input, separation);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.ETIQuickTrend ETIQuickTrend(Data.IDataSeries input, int separation)
        {
            return _indicator.ETIQuickTrend(input, separation);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ETIVolumeWatch ETIVolumeWatch()
        {
            return _indicator.ETIVolumeWatch(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.ETIVolumeWatch ETIVolumeWatch(Data.IDataSeries input)
        {
            return _indicator.ETIVolumeWatch(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ETIAlertCross ETIAlertCross(bool enableAudio, int separation, string soundFileDown, string soundFileUp)
        {
            return _indicator.ETIAlertCross(Input, enableAudio, separation, soundFileDown, soundFileUp);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.ETIAlertCross ETIAlertCross(Data.IDataSeries input, bool enableAudio, int separation, string soundFileDown, string soundFileUp)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ETIAlertCross(input, enableAudio, separation, soundFileDown, soundFileUp);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ETIAverageTrender ETIAverageTrender()
        {
            return _indicator.ETIAverageTrender(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.ETIAverageTrender ETIAverageTrender(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ETIAverageTrender(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ETIDynamicStrength ETIDynamicStrength()
        {
            return _indicator.ETIDynamicStrength(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.ETIDynamicStrength ETIDynamicStrength(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ETIDynamicStrength(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ETIPriceLeader ETIPriceLeader(int separationDot, int separationTriangle)
        {
            return _indicator.ETIPriceLeader(Input, separationDot, separationTriangle);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.ETIPriceLeader ETIPriceLeader(Data.IDataSeries input, int separationDot, int separationTriangle)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ETIPriceLeader(input, separationDot, separationTriangle);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ETIQuickTrend ETIQuickTrend(int separation)
        {
            return _indicator.ETIQuickTrend(Input, separation);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.ETIQuickTrend ETIQuickTrend(Data.IDataSeries input, int separation)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ETIQuickTrend(input, separation);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ETIVolumeWatch ETIVolumeWatch()
        {
            return _indicator.ETIVolumeWatch(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.ETIVolumeWatch ETIVolumeWatch(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ETIVolumeWatch(input);
        }
    }
}
#endregion
